<script>
    import { onMount } from "svelte";
  
    let items = [];
    let name = "";
  
    const addTodo = async () => {
      //call the api to add the todo item
      const res = await fetch(`/api/items`, {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify({ name }),
      }).then((res) => res.json());
  
      await refreshTodos();
  
      name = "";
    };
  
    const refreshTodos = async () => {
      //call the api to get the todo items
      items = await fetch("/api/items").then((res) =>
        res.json()
      );
    };
  
      const deleteTodoItem = async (id) => {
          //call the api to delete the todo item
          await fetch(`/api/items/${id}`, {
              method: "DELETE",
          });
          await refreshTodos();
      };
  
      const updateTodoStatus = (item) => async () => {
          //call the api to update the todo item status
          await fetch(`/api/items/${item.id}`, {
              method: "PUT",
              headers: {
                  "Content-Type": "application/json",
              },
              body: JSON.stringify({ completed: !item.completed }),
          });
          await refreshTodos();
      };
  
  
    onMount(async () => {
      //call the api to get the todo items
      items = await fetch("/api/items").then((res) =>
        res.json()
      );
    });
  </script>
  
  <h1>Items</h1>
  <input type="text" bind:value={name} />
  <button on:click={addTodo}>Add</button>
  <div class="container">
      <ul>
          {#if items.length === 0}
            <div>No items found</div>
          {:else}
            {#each items as item}
              <li>
                <div class="name">
                    {#if item.completed}
                        <s>{item.name}</s>
                    {:else}
                        {item.name}
                    {/if}
                </div>
                <div class="buttons">
                    {#if item.completed}
                        <button on:click={updateTodoStatus(item)}>Mark as incomplete</button>
                    {:else}
                        <button class="delete" on:click={updateTodoStatus(item)}>Mark as complete</button>
                    {/if}
                    <button on:click={() => deleteTodoItem(item.id)}>Delete</button>
                </div>
            </li>
            {/each}
          {/if}
        </ul>
  </div>
  
  <style>
  
      .container {
          max-width: 600px;
          margin: 0 auto;
          padding: 1rem;
          background-color: lightgray;
      }
      ul {
          list-style: none;
          padding: 0;
      }
  
      li {
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-bottom: 0.5rem;
      }
  
      .name {
          flex-grow: 1;
      }
  
      .buttons {
          display: flex;
          justify-content: space-between;
          align-items: center;
      }
  
      button {
          margin-left: 0.5rem;
          border: none;
          border-radius: 0.25rem;
          padding: 0.25rem 0.5rem;
          cursor: pointer;
      }
  </style>
  